import 'dart:convert';
import 'package:flutter/services.dart';

/// Service pour gérer le chargement des catégories depuis un fichier JSON.
class CategoryService {
  /// Méthode pour charger les catégories depuis un fichier JSON.
  /// Cette méthode retourne un Map où chaque clé représente un type de catégorie
  /// et chaque valeur est une liste de catégories associées à ce type.
  Future<Map<String, List<String>>> loadCategories() async {
    try {
      // Charger le fichier JSON à partir des assets
      print('Chargement du fichier JSON des catégories...');
      final String response = await rootBundle.loadString('lib/assets/json/event_categories.json');

      // Décoder le contenu du fichier JSON
      final Map<String, dynamic> data = json.decode(response);
      print('Données JSON décodées avec succès.');

      // Transformer les données en un Map de catégories par type
      final Map<String, List<String>> categoriesByType = (data['categories'] as Map<String, dynamic>).map(
            (key, value) => MapEntry(key, List<String>.from(value)),
      );

      print('Catégories chargées: $categoriesByType');
      return categoriesByType;
    } catch (e) {
      // Gérer les erreurs de chargement ou de décodage
      print('Erreur lors du chargement des catégories: $e');
      throw Exception('Impossible de charger les catégories.');
    }
  }
}
